
#include <config.h>
#include <gtk/gtk.h>
#include <stdint.h>
#include <pop_support.h>
#include "cc-support-panel.h"

struct _CcSupportPanel {
    CcPanel    parent_instance;
};

CC_PANEL_REGISTER (CcSupportPanel, cc_support_panel)

static void cc_support_panel_dispose (GObject *object) {
    G_OBJECT_CLASS (cc_support_panel_parent_class)->dispose (object);
}

static void cc_support_panel_finalize (GObject *object) {
    G_OBJECT_CLASS (cc_support_panel_parent_class)->finalize (object);
}

static void cc_support_panel_class_init (CcSupportPanelClass *klass) {
    GObjectClass *object_class = G_OBJECT_CLASS (klass);

    object_class->dispose = cc_support_panel_dispose;
    object_class->finalize = cc_support_panel_finalize;
}

static gboolean attach_panel (GtkContainer *self) {
    GtkWindow *window = GTK_WINDOW (gtk_widget_get_toplevel (GTK_WIDGET (self)));

    pop_support_attach (self, window);
    gtk_widget_show_all (self);

    return FALSE;
}

static void cc_support_panel_init (CcSupportPanel *self) {
    pop_support_init ();

    // Attach after idling so we'll have access to the window as a toplevel.
    g_idle_add ((GSourceFunc) attach_panel, GTK_CONTAINER (self));
}
